function df = MyDerivative2(NbrePts,x,f,Plot,Method,NaNs)
%% Example
% NbrePts=10; Plot=1;
% x=(-4:0.1:5)'; f=10*x-x.^3;

if isvector(x)==1 && isvector(f)==1
    if size(x,1)==1
        x=x';
    end
    if size(f,1)==1
        f=f';
    end
    if size(x,1)==size(f,1)
        nl=size(x,1); df=zeros(nl,1);
        Ind=(1:nl)';
        NbrePoints=min(min(abs(Ind-1),abs(Ind-nl)),NbrePts);
        if Plot==1
            figure('Name','Vrification de la drivation','NumberTitle','off');
            subplot(1,2,1); hold on;
            plot(x(:,1),f(:,1),'o','MarkerSize',8,'color',[0 0 1]);
        end
        df(1,1)=NaN; df(end,1)=NaN;
        for i=2:nl-1
            Indmin=Ind(i)-NbrePoints(i); Indmax=Ind(i)+NbrePoints(i);
%             p=polyfit(x(Indmin:Indmax,1),f(Indmin:Indmax,1),Method);
            p=MyPolyfit(x(Indmin:Indmax,1),f(Indmin:Indmax,1),Method);
            df(i,1)=polyval(polyder(p),x(Ind(i,1),1));
            if Plot==1
                LocalTest=polyval(p,x(Indmin:Indmax,1));
                plot(x(Indmin:Indmax,1),LocalTest,'-','LineWidth',1,'color',[1 0 0]);
            end
        end
        if NaNs==1
            I=find(NbrePoints<NbrePts);
            df(I)=NaN;
        end
        if Plot==1
            title('Verification of the derivative')
            xlabel('x'); ylabel('f(x)')
            hold off; V=axis;
            AR=(V(4)-V(3))/(V(2)-V(1)); daspect([1 AR 1]);
            set(gca,'FontWeight','bold','FontName','Times New Roman');
            set(gcf,'Color',[1 1 1]);
            set(gca, 'box', 'on')
            set(findall(gcf,'Type','text'),'FontUnits','normalized');
            set(gca,'FontUnits','normalized');
            subplot(1,2,2);
            plot(x(:,1),df(:,1),'o','MarkerSize',8,'color',[0 0 1]);
            title('Derivative')
            xlabel('x'); ylabel('df/dx')
            V=axis; AR=(V(4)-V(3))/(V(2)-V(1)); daspect([1 AR 1]);
            set(gca,'FontWeight','bold','FontName','Times New Roman');
            set(gcf,'Color',[1 1 1]);
            set(gca, 'box', 'on')
            set(findall(gcf,'Type','text'),'FontUnits','normalized');
            set(gca,'FontUnits','normalized');
        end
    end
end

    
end
