function [hAx,Color1,Color2]=MyFigStyleLaTeX_2Y(X,Y1,Y2,xlabel_title,ylabel1_title,ylabel2_title,...
    figure_title,AspectRatio,FontSize,XaxisLim,Yaxis1Lim,Yaxis2Lim,...
    Line_Style,LW,Marker1_Style,MS1,Marker2_Style,MS2)

[hAx,hLine1,hLine2]=plotyy(X,Y1,X,Y2);

if ischar(Line_Style)==1
    hLine1.LineStyle=Line_Style;
end
hLine1.LineWidth=LW;
if ischar(Marker1_Style)==1
    hLine1.Marker=Marker1_Style;
end
hLine1.MarkerSize=MS1; Color1=hLine1.Color;

if ischar(Line_Style)==1
    hLine2.LineStyle=Line_Style;
end
hLine2.LineWidth=LW;
if ischar(Marker2_Style)==1
    hLine2.Marker=Marker2_Style;
end
hLine2.MarkerSize=MS2; Color2=hLine2.Color;

if ischar(xlabel_title)==1
    xlabel(xlabel_title,'Interpreter','latex');
end
if ischar(ylabel1_title)==1
    ylabel(hAx(1),ylabel1_title,'Interpreter','latex');
end
if ischar(ylabel2_title)==1
    ylabel(hAx(2),ylabel2_title,'Interpreter','latex');
end
if ischar(figure_title)==1
    title(figure_title,'Interpreter','latex');
end

set(hAx(1),'TickLabelInterpreter', 'latex','FontSize',FontSize);
set(hAx(2),'TickLabelInterpreter', 'latex','FontSize',FontSize);
set(gcf,'Color',[1 1 1]); set(gca, 'box', 'on');
set(findall(gcf,'Type','text'),'FontSize',FontSize);

if XaxisLim==0
    xminfig=min(X); xmaxfig=max(X);
end
if Yaxis1Lim==0
    ymin1fig=min(Y1); ymax1fig=max(Y1);
end
if Yaxis2Lim==0
    ymin2fig=min(Y2); ymax2fig=max(Y2);
end

if min(Y1)==max(Y1)
    Y10=nanmean(Y1);
    if Y10==0
        dY10=1;
    else
        dY10=0.1*abs(nanmean(Y1));
    end
    ymin1fig=Y10-dY10; ymax1fig=Y10+dY10;
end
if min(Y2)==max(Y2)
    Y20=nanmean(Y2);
    if Y20==0
        dY20=1;
    else
        dY20=0.1*abs(nanmean(Y2));
    end
    ymin2fig=Y20-dY20; ymax2fig=Y20+dY20;
end

if length(XaxisLim)>=2
    xminfig=XaxisLim(1); xmaxfig=XaxisLim(2);
    xlim(hAx(1),[xminfig xmaxfig]); xlim(hAx(2),[xminfig xmaxfig]);
end
if length(Yaxis1Lim)>=2
    ymin1fig=Yaxis1Lim(1); ymax1fig=Yaxis1Lim(2);
end
if length(Yaxis2Lim)>=2
    ymin2fig=Yaxis2Lim(1); ymax2fig=Yaxis2Lim(2);
end
ylim(hAx(1),[ymin1fig ymax1fig]); ylim(hAx(2),[ymin2fig ymax2fig]);

if length(XaxisLim)==3
    xintfig=XaxisLim(3);
    set(hAx(1),'XTick',xminfig-mod(xminfig,xintfig):xintfig:xmaxfig);
    set(hAx(2),'XTick',xminfig-mod(xminfig,xintfig):xintfig:xmaxfig);
end
if length(Yaxis1Lim)==3
    yint1fig=Yaxis1Lim(3);
    set(hAx(1),'YTick',ymin1fig-mod(ymin1fig,yint1fig):yint1fig:ymax1fig); 
end
if length(Yaxis2Lim)==3
    yint2fig=Yaxis2Lim(3);
    set(hAx(2),'YTick',ymin2fig-mod(ymin2fig,yint2fig):yint2fig:ymax2fig);    
end

if AspectRatio>0
    AR1=(ymax1fig-ymin1fig)/(xmaxfig-xminfig); daspect(hAx(1),[1 AspectRatio*AR1 1]);
    AR2=(ymax2fig-ymin2fig)/(xmaxfig-xminfig); daspect(hAx(2),[1 AspectRatio*AR2 1]);
end


end


