function [a,b,sa,sb,SP] = My_linear_regression_GG(x, y, err_y)
%CREATEFIT(X,Y,ERR_Y)
%  Create a fit.
%  Data for 'untitled fit 1' fit:
%      X Input : x
%      Y Output: y
%      Weights : err_y
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%  See also FIT, CFIT, SFIT.
%  Auto-generated by MATLAB on 10-Feb-2020 16:44:15


%% Fit: 'untitled fit 1'.
SP=polyfit(x,y,1);


[xData, yData, weights] = prepareCurveData( x, y, err_y );

% Set up fittype and options.
ft = fittype( 'a*x + b', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Algorithm = 'Levenberg-Marquardt';
opts.Display = 'Off';
opts.StartPoint = SP;;
opts.Weights = weights;

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

% % Plot fit with data.
% figure( 'Name', 'untitled fit 1' );
% h = plot( fitresult, xData, yData );
% legend( h, 'y vs. x with err_y', 'untitled fit 1', 'Location', 'NorthEast' );
% % Label axes
% xlabel x
% ylabel y
% grid on

a=fitresult.a;b=fitresult.b;
cf=confint(fitresult);
sa = (cf(2,1)-cf(1,1))/2;
sb = (cf(2,2)-cf(1,2))/2;



