function MatFilePositions=TIRF_FindMatFilePositions(FolderResults,...
    Filtering,MinPixel,MaxPixel,GaussBlur,ThresholdPart,Method,AirMinDetection,TolArea)

ListMatFiles=dir([FolderResults filesep '*.mat']);
nl=numel(ListMatFiles); InfosDetect=NaN(nl,7);
for i=1:nl
    
    Name=ListMatFiles(i).name;
    I=strfind(Name,'Filt'); J=strfind(Name,'Detect');
    K=strfind(Name,'TolA'); L=strfind(Name,'.mat');
    
    if isempty(I)==0 && isempty(J)==0 && isempty(K)==0 && isempty(L)==0
        
        % Filtering
        NameFilt=Name(I:J-2); M=strfind(NameFilt,'-');
        if isempty(M)==0
            InfosDetect(i,1)=str2double(NameFilt(5:M(1)-1)); % Filtering
            InfosDetect(i,2)=str2double(NameFilt(M(1)+1:M(2)-1)); % MinPixel
            InfosDetect(i,3)=str2double(NameFilt(M(2)+1:end)); % MaxPixel
        end

        % Detection
        NameDetect=Name(J:K-2); P=strfind(NameDetect,'GB');
        Q=strfind(NameDetect,'TP'); R=strfind(NameDetect,'M');
        S=strfind(NameDetect,'Am');
        if isempty(P)==0 && isempty(Q)==0 && isempty(R)==0
            InfosDetect(i,4)=str2double(NameDetect(P+2:Q-1));
            InfosDetect(i,5)=str2double(NameDetect(Q+2:R-1));
            InfosDetect(i,6)=str2double(NameDetect(R+1:S-1));
            InfosDetect(i,7)=str2double(NameDetect(S+2:end));
        end

        % 2d-Gaussian fit
        InfosDetect(i,8)=str2double(Name(K+4:L-1));
        
    end
    
end

I=(InfosDetect(:,1)==Filtering & InfosDetect(:,2)==MinPixel & ...
    InfosDetect(:,3)==MaxPixel & InfosDetect(:,4)==GaussBlur & ...
    InfosDetect(:,5)==ThresholdPart & InfosDetect(:,6)==Method & ...
    InfosDetect(:,7)==AirMinDetection & InfosDetect(:,8)==TolArea);

% MatFilePositions=[FolderResults filesep ListMatFiles(I==1).name];
MatFilePositions=[FolderResults filesep Name];

end