function [PosVelocities,DeltaTime]=Traj2Velocities_TS(time,positions)

[np,nd]=size(positions);
Mdiff=zeros(np,np,nd); Mmean=zeros(np,np,nd);
for i=1:nd
    Mdiff(:,:,i)=repmat(positions(:,i),[1 np 1])-repmat(positions(:,i)',[np 1 1]);
%     Mmean(:,:,i)=(repmat(positions(:,i),[1 np 1])+repmat(positions(:,i)',[np 1 1]))/2;
    for r=1:np
        for c=1:np
            if r==c
                Mmean(r,c,i)=0;
            elseif r<c
                Mmean(r,c,i)=sum(positions(r:c,i))/length(positions(r:c,i));
            elseif r>c
                Mmean(r,c,i)=sum(positions(c:r,i))/length(positions(c:r,i));
            end
        end
    end
end
T2=repmat(time,[1 np 1])-repmat(time',[np 1 1]);

PosVelocities=cell(1,np-1); DeltaTime=zeros(1,np-1);
for i=1:np-1
    PosVelocities{i}=zeros(np-i,nd*2);
    if length(unique(diag(T2(i+1:end,1:end-i))))==1
        DeltaTime(i)=unique(diag(T2(i+1:end,1:end-i)));
    elseif length(unique(diag(T2(i+1:end,1:end-i))))>1
        MeanTau=mean(diag(T2(i+1:end,1:end-i)));
        StdTau=std(diag(T2(i+1:end,1:end-i)));
        if 100*StdTau/MeanTau<1e-3
            DeltaTime(i)=mean(diag(T2(i+1:end,1:end-i)));
        else
            error(['tau = ' num2str(DeltaTime(i)) ' pm ' num2str(std(diag(T2(i+1:end,1:end-i))))]);
        end
    end
    for j=1:nd
        Mdiffpart=Mdiff(i+1:end,1:end-i,j);
        Mmeanpart=Mmean(i+1:end,1:end-i,j);
%         PosVelocities{i}(:,j+nd)=diag(Mdiffpart)/DeltaTime(i);
        PosVelocities{i}(:,j+nd)=diag(Mdiffpart);
        PosVelocities{i}(:,j)=diag(Mmeanpart);
    end
end



end