function [result] = find_best_regression_velocity_profile(Xtest,Ytest,Ntest)

if nargin ~=2
    X=[];Y=[];
    for k=1:length(Xtest(1,:));
        X=horzcat(X , repmat(Xtest(:,k),[1 Ntest(k)]) );
        Y=horzcat(Y , repmat(Ytest(:,k),[1 Ntest(k)]) );
    end
    Xtest=X;Ytest=Y;
end
 



for k=1:length(Xtest(:,1))
    coefs_lin(k,:) = polyfit(Xtest(k,:),Ytest(k,:),1);
end
    
indices_list=linspace(min(-coefs_lin(:,2)./coefs_lin(:,1)),...
             max(-coefs_lin(:,2)./coefs_lin(:,1)),100);

err=zeros(1,100);
for k=1:100
    fun_lin= @(x,xdata) x(1)*(xdata - indices_list(k));
    x0=[( Ytest(2,end)-Ytest(2,1) )/(Xtest(2,end) -Xtest(2,1)) ];
    for p=1:length(Xtest(:,1))
        [a,resnorm] =  lsqcurvefit(fun_lin,x0,Xtest(p,:),Ytest(p,:));
        err(k)=err(k)+resnorm;
    end
end

figure,plot(indices_list,err)
GG_Figstyle
xlabel('$-\log(I)$ value at which regression cut x-axis')
ylabel('Error')

[~, index_min]=min(err);
result=indices_list(index_min);
end

