function [intercept_x,intercept_y,error_intercept] = get_intercept(test,display,N)


%%
x0=-mean(test(:,2)./test(:,1));
y0=0;

x_vector=linspace(x0-3,x0+3,N);
y_vector = linspace(-10 , 10 , N);
%figure(1),xlim([min(x_vector) max(x_vector)]),ylim([min(y_vector) max(y_vector)])

error = zeros(length(x_vector),length(y_vector));
error_min = 1e10;
for ii=1:length(x_vector)
    for jj=1:length(y_vector)
        x = x_vector(ii) ; y=y_vector(jj);
        for k=1:length(test(:,1))
            error(ii,jj) = error(ii,jj) + distance_intercept(x,y,test(k,1),test(k,2)).^2;
        end
        error(ii,jj) =  error(ii,jj)/length(test(:,1));
        if error(ii,jj)<error_min
            error_min=error(ii,jj);
            x_i = x_vector(ii);y_i = y_vector(jj);
        end
    end
end

error_intercept = std(   (y_i-test(:,2) )./test(:,1)  );
intercept_x=x_i;
intercept_y=y_i;

if display==1
    figure,clf,hold on
    subplot(121),hold on
    for k=1:length(test(:,1))
        fplot(@(x) test(k,1)*x + test(k,2),[x_i-2 x_i+10],'k')
    end
    errorbar(x_i,y_i,error_intercept,'horizontal','ro','Markersize',4,'Linewidth',1)
     plot((y_i-test(:,2) )./test(:,1) , y_i*ones(1,length(test(:,2))) ,'bx')
    subplot(122),imagesc(x_vector,y_vector,error),colorbar
end

