%% Calcul de La Grosse Matrice (N_frames_max,N_Particules,4) pour une fréquenmce donnée, change la variable freq pour choisir quelle frequence tu etudies
clear all
clc
dt = 1/20; %dt en secondes
dx = 5e-2/592; %dx d'un pixel en m
freq = 2021; %fréquence que l'on étudie
partot = 0;  %nombre total ;aximal de particules étudiées 
framax = 0;  %Nombre maximal de frames pour la fréquence étudiée 
for i=1:10
    path_data = strcat('E:\PSE21\Videos_freqs',filesep,num2str(i),filesep,num2str(freq)); % path to data
    format = '.tiff'; % picture format
    A = dir([path_data filesep '*' format]);frames=length(A);
    
    if frames > framax
        framax = frames;
    end
    
end
 
for i=1:10
    
    [A,B,C] = traj_exp(freq,i);
    partot = partot + B;
    
    i
    
    if i == 1
        Mg = zeros(framax,partot,4);
        Mg(1:C,:,:) = A;
    else 
        Mg_temp = zeros(framax,B,4);
        Mg_temp(1:C,:,:) = A;
        Mg = cat(2,Mg,Mg_temp);
    end
    
end



%% Construction des bins et carte des vitesses 37*37 bins de 16 par 16 rien a changer, c'est les grosses bins

Vitesses = zeros(592,592);
Vitesses_bins = zeros(37,37,3);

for i=1:37
    for j=1:37
        i/37*100
        Cond = (((16*(i-1)<=Mg(:,:,1).*(Mg(:,:,1)<16*i)).*((16*(j-1)<=Mg(:,:,2)).*(Mg(:,:,2)<16*j)))).*((Mg(:,:,1)>0).*(Mg(:,:,2)>0));
        Cond = Cond/sum(sum(Cond));
        Vitesses_bins(i,j,1) = Vitesses_bins(i,j,1) + sum(sum((Mg(:,:,3).*Cond))); %Vx
        Vitesses_bins(i,j,2) = Vitesses_bins(i,j,2) + sum(sum((Mg(:,:,4).*Cond))); %Vy
        Vitesses_bins(i,j,3) = sqrt(Vitesses_bins(i,j,1)^2+Vitesses_bins(i,j,2)^2); % |V|
    end
end

figure;
imagesc(Vitesses_bins(:,:,3));caxis([0 1]);


%% Construction des bins et carte des vitesses 74*74 bins de 8 par 8 rien a changer, c'est les petites bins

Vitesses = zeros(592,592);
Vitesses_bins = zeros(74,74,3);

for i=1:74
    for j=1:74
        i/74*100
        Cond = (((8*(i-1)<=Mg(:,:,1).*(Mg(:,:,1)<8*i)).*((8*(j-1)<=Mg(:,:,2)).*(Mg(:,:,2)<8*j)))).*(Mg(:,:,1)>0).*(Mg(:,:,2)>0);
        Cond = Cond/sum(sum(Cond));
        Vitesses_bins(i,j,1) = Vitesses_bins(i,j,1) + sum(sum((Mg(:,:,3).*Cond))); %Vx
        Vitesses_bins(i,j,2) = Vitesses_bins(i,j,2) + sum(sum((Mg(:,:,4).*Cond))); %Vy
        Vitesses_bins(i,j,3) = sqrt(Vitesses_bins(i,j,1)^2+Vitesses_bins(i,j,2)^2); % |V|
    end
end

figure;
imagesc(Vitesses_bins(:,:,3));caxis([0 3]);

%% Application passe-bas gaussien a appliquer pour smoother, sigma est la variance du filtre gaussien

sigma = 0.4;
Vitesses_bins_filt = imgaussfilt(Vitesses_bins,sigma);

figure;
imagesc(Vitesses_bins_filt);caxis([0 4]);

%% Comparaison Air et Eau a fréquence donnée il faut donner la frequence de l'air ET de l'eau, pour les plaques exotiques, c'est dans AC_Normale_Inverse, pour les normales dans video freqs
clear all 
clc

dt = 1/20; %dt en secondes
dx = 5e-2/592; %dx d'un pixel en m
freqair = 5670;
freqeau = 1970;
partoteau = 0;  %nombre total maximal de particules étudiées 
framaxeau = 0;  %Nombre maximal de frames pour la fréquence étudiée 
partotair = 0;  %nombre total maximal de particules étudiées 
framaxair = 0;  %Nombre maximal de frames pour la fréquence étudiée 

for serie=1:10
    %path_data = strcat('E:\Ac_normale_inverse',filesep,'air',filesep,num2str(freqair),"_",num2str(serie)); % path to data
    path_data= strcat('E:\PSE21\triangle\air',filesep,num2str(serie));
    format = '.tiff'; % picture format
    A = dir([strcat(path_data ,filesep ,'*', format)]);frames=length(A);
    
    if frames > framaxair
        framaxair = frames;
    end
    
end
 
for i=1:10
    
    [A,B,C] = traj_exp_inv(freqair,i,'air');
    partotair = partotair + B;
    
    i
    
    if i == 1
        Mgair = zeros(framaxair,partotair,4);
        Mgair(1:C,:,:) = A;
    else 
        Mg_temp = zeros(framaxair,B,4);
        Mg_temp(1:C,:,:) = A;
        Mgair = cat(2,Mgair,Mg_temp);
    end
    
end

for serie=1:10
    %path_data = strcat('E:\Ac_normale_inverse',filesep,'eau',filesep,num2str(freqeau),"_",num2str(serie)); % path to data
    path_data= strcat('E:\PSE21\triangle\eau',filesep,num2str(serie));
    format = '.tiff'; % picture format
    A = dir([strcat(path_data ,filesep ,'*', format)]);frames=length(A);
    
    if frames > framaxeau
        framaxeau = frames;
    end
    
end
 
for i=1:10
    
    [A,B,C] = traj_exp_inv(freqeau,i,'eau');
    partoteau = partoteau + B;
    
    i
    
    if i == 1
        Mgeau = zeros(framaxeau,partoteau,4);
        Mgeau(1:C,:,:) = A;
    else 
        Mg_temp = zeros(framaxeau,B,4);
        Mg_temp(1:C,:,:) = A;
        Mgeau = cat(2,Mgeau,Mg_temp);
    end
    
end



%% Bins de 8*8 binage pour les comparaisons

Vitessesair = zeros(592,592);
Vitessesair_bins = zeros(74,74,3);

for i=1:74
    for j=1:74
        strcat("Bins air ",num2str(i/74*100)," %")
        Cond = (((8*(i-1)<=Mgair(:,:,1).*(Mgair(:,:,1)<8*i)).*((8*(j-1)<=Mgair(:,:,2)).*(Mgair(:,:,2)<8*j)))).*(Mgair(:,:,1)>0).*(Mgair(:,:,2)>0);
        Cond = Cond/sum(sum(Cond));
        Vitessesair_bins(i,j,1) = Vitessesair_bins(i,j,1) + sum(sum((Mgair(:,:,3).*Cond))); %Vx
        Vitessesair_bins(i,j,2) = Vitessesair_bins(i,j,2) + sum(sum((Mgair(:,:,4).*Cond))); %Vy
        Vitessesair_bins(i,j,3) = sqrt(Vitessesair_bins(i,j,1)^2+Vitessesair_bins(i,j,2)^2); % |V|
    end
end

Vitesseseau = zeros(592,592);
Vitesseseau_bins = zeros(74,74,3);

for i=1:74
    for j=1:74
        strcat("Bins eau ",num2str(i/74*100)," %")
        Cond = (((8*(i-1)<=Mgeau(:,:,1).*(Mgeau(:,:,1)<8*i)).*((8*(j-1)<=Mgeau(:,:,2)).*(Mgeau(:,:,2)<8*j)))).*(Mgeau(:,:,1)>0).*(Mgeau(:,:,2)>0);
        Cond = Cond/sum(sum(Cond));
        Vitesseseau_bins(i,j,1) = Vitesseseau_bins(i,j,1) + sum(sum((Mgeau(:,:,3).*Cond))); %Vx
        Vitesseseau_bins(i,j,2) = Vitesseseau_bins(i,j,2) + sum(sum((Mgeau(:,:,4).*Cond))); %Vy
        Vitesseseau_bins(i,j,3) = sqrt(Vitesseseau_bins(i,j,1)^2+Vitesseseau_bins(i,j,2)^2); % |V|
    end
end

%% Bins de 16*16 binage pour les comparaisons

Vitessesair = zeros(592,592);
Vitessesair_bins = zeros(37,37,3);

for i=1:37
    for j=1:37
        strcat("Bins air ",num2str(i/37*100)," %")
        Cond = (((16*(i-1)<=Mgair(:,:,1).*(Mgair(:,:,1)<16*i)).*((16*(j-1)<=Mgair(:,:,2)).*(Mgair(:,:,2)<16*j)))).*(Mgair(:,:,1)>0).*(Mgair(:,:,2)>0);
        Cond = Cond/sum(sum(Cond));
        Vitessesair_bins(i,j,1) = Vitessesair_bins(i,j,1) + sum(sum((Mgair(:,:,3).*Cond))); %Vx
        Vitessesair_bins(i,j,2) = Vitessesair_bins(i,j,2) + sum(sum((Mgair(:,:,4).*Cond))); %Vy
        Vitessesair_bins(i,j,3) = sqrt(Vitessesair_bins(i,j,1)^2+Vitessesair_bins(i,j,2)^2); % |V|    end
    end
end

Vitesseseau = zeros(592,592);
Vitesseseau_bins = zeros(37,37,3);

for i=1:37
    for j=1:37
        strcat("Bins eau ",num2str(i/37*100)," %")
        Cond = (((16*(i-1)<=Mgeau(:,:,1).*(Mgeau(:,:,1)<16*i)).*((16*(j-1)<=Mgeau(:,:,2)).*(Mgeau(:,:,2)<16*j)))).*(Mgeau(:,:,1)>0).*(Mgeau(:,:,2)>0);
        Cond = Cond/sum(sum(Cond));
        Vitesseseau_bins(i,j,1) = Vitesseseau_bins(i,j,1) + sum(sum((Mgeau(:,:,3).*Cond))); %Vx
        Vitesseseau_bins(i,j,2) = Vitesseseau_bins(i,j,2) + sum(sum((Mgeau(:,:,4).*Cond))); %Vy
        Vitesseseau_bins(i,j,3) = sqrt(Vitesseseau_bins(i,j,1)^2+Vitesseseau_bins(i,j,2)^2); % |V|
    end
end


%% Epurage des NaN et Rescaling passage obligatoire pour pas que ce soit ignoble necessaire

Vitessesair_bins(isnan(Vitessesair_bins)) = 0;
Vitesseseau_bins(isnan(Vitesseseau_bins)) = 0;

Vitesseseau_bins(:,:,1) = dx*Vitesseseau_bins(:,:,1)/dt;
Vitesseseau_bins(:,:,2) = dx*Vitesseseau_bins(:,:,2)/dt;
Vitesseseau_bins(:,:,3) = dx*Vitesseseau_bins(:,:,3)/dt;


Vitessesair_bins(:,:,1) = dx*Vitessesair_bins(:,:,1)/dt;
Vitessesair_bins(:,:,2) = dx*Vitessesair_bins(:,:,2)/dt;
Vitessesair_bins(:,:,3) = dx*Vitessesair_bins(:,:,3)/dt;


3
%% Affichage  ici le but est de bien trouver le bon scale / axis joue avec caxis pour changer de critere : absolu on enfontion de la moyenne / std des valeurs

figure;
subplot(1,2,1);imagesc([5e-2/592 5e-2],[5e-2/592 5e-2],Vitessesair_bins(:,:,3));title("Resonnance in the air (9677Hz): |V|");caxis([0 mean(mean(Vitessesair_bins(:,:,3)))+3*std(std(Vitessesair_bins(:,:,3)))]);colormap('jet');
subplot(1,2,2);imagesc([5e-2/592 5e-2],[5e-2/592 5e-2],Vitesseseau_bins(:,:,3));title("Resonnance in the water (3950Hz): |V|");caxis([0 mean(mean(Vitesseseau_bins(:,:,3)))+2*std(std(Vitesseseau_bins(:,:,3)))]);colormap('jet');

figure;
subplot(1,2,1);imagesc(Vitessesair_bins(:,:,1));title("Resonnance in the air (9677Hz): Vx");caxis([mean(mean(Vitessesair_bins(:,:,1)))-3*std(std(Vitessesair_bins(:,:,1))) mean(mean(Vitessesair_bins(:,:,1)))+3*std(std(Vitessesair_bins(:,:,1)))]);colormap('jet');
subplot(1,2,2);imagesc(Vitessesair_bins(:,:,2));title("Resonnance in the air (9677Hz): Vy");caxis([mean(mean(Vitessesair_bins(:,:,2)))-3*std(std(Vitessesair_bins(:,:,2))) mean(mean(Vitessesair_bins(:,:,2)))+3*std(std(Vitessesair_bins(:,:,2)))]);colormap('jet');

figure;
subplot(1,2,1);imagesc(Vitesseseau_bins(:,:,1));title("Resonnance in the water (3950Hz): Vx");caxis([mean(mean(Vitesseseau_bins(:,:,1)))-3*std(std(Vitesseseau_bins(:,:,1))) mean(mean(Vitesseseau_bins(:,:,1)))+3*std(std(Vitesseseau_bins(:,:,1)))]);colormap('jet');
subplot(1,2,2);imagesc(Vitesseseau_bins(:,:,2));title("Resonnance in the water (3950Hz): Vy");caxis([mean(mean(Vitesseseau_bins(:,:,2)))-3*std(std(Vitesseseau_bins(:,:,2))) mean(mean(Vitesseseau_bins(:,:,2)))+3*std(std(Vitesseseau_bins(:,:,2)))]);colormap('jet');

figure;
quiver(Vitesseseau_bins(:,:,1),Vitesseseau_bins(:,:,2),1)

%% Filtrage Gaussien pareil

sigma = 0.3;
Vitesses_bins_filtair = imgaussfilt(Vitessesair_bins,sigma);
Vitesses_bins_filteau = imgaussfilt(Vitesseseau_bins,sigma);

figure;
subplot(1,2,1);imagesc(Vitesses_bins_filtair(:,:,3));title("Resonnance in the air (9677Hz)");caxis([mean(mean(Vitesses_bins_filtair(:,:,3)))-2*std(std(Vitesses_bins_filtair(:,:,3))) mean(mean(Vitesses_bins_filtair(:,:,3)))+2*std(std(Vitesses_bins_filtair(:,:,3)))]);colormap('jet');
subplot(1,2,2);imagesc(Vitesses_bins_filteau(:,:,3));title("Resonnance in the water (3950Hz)");caxis([mean(mean(Vitesses_bins_filteau(:,:,3)))-2*std(std(Vitesses_bins_filteau(:,:,3))) mean(mean(Vitesses_bins_filteau(:,:,3)))+2*std(std(Vitesses_bins_filteau(:,:,3)))]);colormap('jet');



%%











