%% Allez hop
clear all
clc
dt = 1/20; %dt en secondes
dx = 5e-2/592; %dx d'un pixel en m
freqs =  [1000 1124 1264 1422 1599 1798 2021 2273 2556 2874 3231 3633 4085 4594 5165 5808 6531 7343 8257 9285 10440 11739 13200 14843 16690 18766 21102 23727 26680 30000]; 

filename = 'freqs.avi'; % Specify the output file name
v = VideoWriter('freqs.avi','Motion JPEG AVI');
open(v)
for freq = freqs
    
    partot = 0;  %nombre total maximal de particules étudiées 
framax = 0;  %Nombre maximal de frames pour la fréquence étudiée 
for i=1:10
    path_data = strcat('E:\PSE21\Videos_freqs',filesep,num2str(i),filesep,num2str(freq)); % path to data
    format = '.tiff'; % picture format
    A = dir([path_data filesep '*' format]);frames=length(A);
    
    if frames > framax
        framax = frames;
    end
    
end
 
for i=1:10
    
    [A,B,C] = traj_exp(freq,i);
    partot = partot + B;
    
    i
    
    if i == 1
        Mg = zeros(framax,partot,4);
        Mg(1:C,:,:) = A;
    else 
        Mg_temp = zeros(framax,B,4);
        Mg_temp(1:C,:,:) = A;
        Mg = cat(2,Mg,Mg_temp);
    end
    
end

Vitesses = zeros(592,592);
Vitesses_bins = zeros(37,37,3);

for i=1:37
    for j=1:37
        i/37*100
        Cond = (((16*(i-1)<=Mg(:,:,1).*(Mg(:,:,1)<16*i)).*((16*(j-1)<=Mg(:,:,2)).*(Mg(:,:,2)<16*j)))).*((Mg(:,:,1)>0).*(Mg(:,:,2)>0));
        Cond = Cond/sum(sum(Cond));
        Vitesses_bins(i,j,1) = Vitesses_bins(i,j,1) + sum(sum((Mg(:,:,3).*Cond))); %Vx
        Vitesses_bins(i,j,2) = Vitesses_bins(i,j,2) + sum(sum((Mg(:,:,4).*Cond))); %Vy
        Vitesses_bins(i,j,3) = sqrt(Vitesses_bins(i,j,1)^2+Vitesses_bins(i,j,2)^2); % |V|
    end
end

Vitesses_bins(:,:,1) = dx*Vitesses_bins(:,:,1)/dt;
Vitesses_bins(:,:,2) = dx*Vitesses_bins(:,:,2)/dt;
Vitesses_bins(:,:,3) = dx*Vitesses_bins(:,:,3)/dt;


Vitesses_bins(isnan(Vitesses_bins)) = 0;

f=figure;
imagesc([5e-2/592 5e-2],[5e-2/592 5e-2],Vitesses_bins(:,:,3));caxis([0 mean(mean(Vitesses_bins(:,:,3)))+5*std(std(Vitesses_bins(:,:,3)))]);title("Norme de la vitesse (m.s^-1) en fonction de la position (m)");
xlabel("x");ylabel("y");title(strcat("f=",num2str(round(freq)),"Hz"));colorbar;colormap("jet");

saveas(f,strcat("speed_map_",num2str(round(freq))),"png")

drawnow
frame=getframe(gcf);
writeVideo(v,frame);

close(f)
    
end